package gamegraphics
{
   import flash.display.Bitmap;
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.EventDispatcher;
   import game.Game;
   import game.GameObject;
   import game.ObjectCreatedEvent;
   
   public class GameGraphics extends EventDispatcher
   {
      
      public static var sprite:Sprite;
       
      
      private var theGame:Game;
      
      private var bgImage:GameImage;
      
      private var imagesToLoad:int;
      
      private var objectArray:Array;
      
      private var imageArray:Object;
      
      public function GameGraphics(fathersprite:Sprite, theGame:Game)
      {
         objectArray = new Array();
         imageArray = new Object();
         super();
         sprite = fathersprite;
         this.theGame = theGame;
         theGame.addEventListener("objectCreated",addObject);
      }
      
      public function addObject(event:ObjectCreatedEvent) : void
      {
         new GraphicsObject(event.getObject(),event.objClass,event.frameDelay,event.loop,event.overWidth,event.overHeight);
      }
      
      public function addImage(obj:GameObject, imageClass:Class, frameDelay:int = 0, loop:Boolean = false) : void
      {
         new GraphicsObject(obj,imageClass,frameDelay,loop);
      }
      
      public function loadImages(images:Object) : void
      {
         var image:String = null;
         var newImage:GameImage = null;
         for(image in images)
         {
            ++imagesToLoad;
            newImage = new GameImage(images[image]);
            newImage.addEventListener(Event.COMPLETE,imageReady);
            imageArray[image] = newImage;
         }
      }
      
      public function imageReady(event:Event) : void
      {
         --imagesToLoad;
         if(imagesToLoad <= 0)
         {
            dispatchEvent(new Event(Event.COMPLETE));
         }
      }
      
      public function setBackGroundImage(imageClass:Class) : void
      {
         bgImage = new GameImage(imageClass);
         addBG(null);
      }
      
      public function addBG(event:Event) : void
      {
         var image:Bitmap = new Bitmap(bgImage.imageData);
         sprite.addChild(image);
         sprite.setChildIndex(image,0);
      }
   }
}
